/******************************************************************************
 * pcm.h
 *-----------------------------------------------------------------------------
 * Copyright (C) 2014-2015 Osman Celimli
 * For conditions of distribution and use, see copyright notice in hscc.c
 ******************************************************************************/
#ifndef PCM
#define PCM

#define PCM_PLAYBACK_RATE		6992.0

#define PCM_MAGICWORD			"PCM"
#define PCM_HEADER_OFFSET_MAGIC	0
#define PCM_HEADER_OFFSET_COUNT	3
#define PCM_HEADER_LEN			4

#define PCM_ENTRY_MAGICWORD		'X'
#define PCM_ENTRY_OFFSET_MAGIC	0
#define PCM_ENTRY_OFFSET_ADDR	1
#define PCM_ENTRY_OFFSET_ADDRL	PCM_ENTRY_OFFSET_ADDR + 0
#define PCM_ENTRY_OFFSET_ADDRH	PCM_ENTRY_OFFSET_ADDR + 1
#define PCM_ENTRY_OFFSET_ADDRB	PCM_ENTRY_OFFSET_ADDR + 2
#define PCM_ENTRY_OFFSET_ADDRM	PCM_ENTRY_OFFSET_ADDR + 3
#define PCM_ENTRY_OFFSET_SIZE	5
#define PCM_ENTRY_OFFSET_SIZEL	PCM_ENTRY_OFFSET_SIZE + 0
#define PCM_ENTRY_OFFSET_SIZEM	PCM_ENTRY_OFFSET_SIZE + 1
#define PCM_ENTRY_OFFSET_SIZEH	PCM_ENTRY_OFFSET_SIZE + 2
#define PCM_ENTRY_LEN			8

#define PCM_MAX_ENTRIES			255
#define PCM_MAX_STREAMLEN		(8 * 1024 * 1024)

typedef struct PCM_Entry
{
	HuAddress HuOffset;

	char *pSampleData;
	int16p16_t Size;
} PCM_Entry;
/******************************************************************************
 * Function Defines
 ******************************************************************************/
int pcm_buildBlock(FILE *pDest, FILE **ppSrcs, unsigned int uiFiles);
#endif
